/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package minetweaker.mc18.actions;

import minetweaker.IUndoableAction;
import minetweaker.MineTweakerAPI;
import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;

/**
 * @author Jared
 */
public class SetBlockHardnessAction implements IUndoableAction{

    private final ItemStack stack;
    private final float hardness;
    private final float oldHardness;

    public SetBlockHardnessAction(ItemStack stack, float hardness){
        this.stack = stack;
        this.hardness = hardness;
        this.oldHardness = Block.func_149634_a(stack.func_77973_b()).func_176195_g(null,null);
    }

    private static void set(ItemStack stack, float hardness){
        if(isBlock(stack)){
            Block block = Block.func_149634_a(stack.func_77973_b());
            block.func_149711_c(hardness);
        }else{
            MineTweakerAPI.logError("Item is not a block");
        }
    }

    public static boolean isBlock(ItemStack stack){
        ResourceLocation name = Block.field_149771_c.func_177774_c(Block.func_149634_a(stack.func_77973_b()));
        return !name.toString().equals("minecraft:air") && Block.field_149771_c.func_148741_d(name);

    }

    @Override
    public void apply(){
        if(isBlock(stack)){
            set(stack, hardness);
        }
    }

    @Override
    public boolean canUndo(){
        return true;
    }

    @Override
    public void undo(){
        if(isBlock(stack))
            set(stack, oldHardness);
    }

    @Override
    public String describe(){
        if(isBlock(stack)){
            return "Setting hardness of " + stack.func_82833_r() + " to " + hardness;
        }
        return "Unable to set hardness of " + stack.func_82833_r() + " because it is an Item";
    }

    @Override
    public String describeUndo(){
        if(isBlock(stack)){
            return "Reverting hardness of " + stack.func_82833_r() + " to " + oldHardness;
        }
        return "Unable to revert hardness of " + stack.func_82833_r() + " because it is an Item";
    }

    @Override
    public Object getOverrideKey(){
        return null;
    }
}
